/***********************************************************************************************/
/************************************** ericmath.c *********************************************/
/***********************************************************************************************/

#define __ERICMATH
#include "ericmath.h"

/***********************************************************************************************/
/******** sec **********************************************************************************/
/***********************************************************************************************/
double sec(double number)
{
	return(1.0/cos(number));
}

/***********************************************************************************************/
/********************************* Compute the sign ********************************************/
/***********************************************************************************************/ 
double sign(double input)
{
   double result = 0.0;
   if (input > 0.0) result = 1.0;
   if (input < 0.0) result = -1.0;

   return(result);

}

/***********************************************************************************************/
/********************************* Create a square wave ****************************************/
/***********************************************************************************************/ 
double squarewave(double frequency, double amplitude, double mean)
{
   
   double wave;

   wave = amplitude*sign(sin(beat*DT*TWO_PI*frequency)) + mean;

   return(wave);
}

/***********************************************************************************************/
/********************************* Create a sine wave ******************************************/
/***********************************************************************************************/ 
double sinewave(double frequency, double amplitude, double mean)
{
   
   double wave;

   wave = amplitude*sin(beat*DT*TWO_PI*frequency) + mean;

   return(wave);
}