/***********************************************************************************************/
/************************************ gui.h ****************************************************/
/***********************************************************************************************/

#ifndef GUI_H 
#define GUI_H 

/***********************************************************************************************/
/************************************ Standard Headers *****************************************/
/***********************************************************************************************/
#include <iostream.h>
#include <curses.h>

/***********************************************************************************************/
/**************************************** My Headers *******************************************/
/***********************************************************************************************/
#ifdef __GUI
#include "mydefines.h"
#include "control.h"
#include "logging.h"
#include "command.h"
#include "servotogo.h"
#endif

void InitializeDisplay();

void UpdateScreen();
void DisplayInputWindow();
void DisplayOutputWindow();

void DrawStaticInfo();
void StaticTitleFootnoteWindows();
void StaticErrorWindow();
void StaticInputWindow();
void StaticOutputWindow();

void Free_Windows();
void PrintErrorMsg(char* s);
void DisplayErrorMsg();
void ScrollErrorMsg(int updown);

#define WB 1
#define YB 2
#define RB 3
#define MB 4
#define GB 5
#define BB 6
#define CB 7
#define KB 8

#define SIZE_MSG_BUFFER		500

#define INPUT_WIN_HEIGHT	25
#define INPUT_WIN_WIDTH 	40
#define OUTPUT_WIN_HEIGHT	25
#define OUTPUT_WIN_WIDTH	40
#define ERR_WIN_HEIGHT		10
#define ERR_WIN_WIDTH		80

#define TITLE_WIDTH			80
#define DATETIME_WIDTH		40
#define INTERRUPT_WIDTH		40
#define TIMESTEP_WIDTH		40
#define CPU_WIDTH				40
#define HEARTBEAT_WIDTH		30
#define FILENAME_WIDTH		80
#define MAINSTATUS_WIDTH   50

#define INPUT_col0				1
#define INPUT_col1				25

#define OUTPUT_col0				1
#define OUTPUT_col1				25

#define DISPLAY_FREQUENCY			50						// milliseconds

typedef struct MSG_TYPE{
	char msg[250];
}MSG_TYPE;

#ifdef __MAIN
	#define EXTERN
	MSG_TYPE *old_msgs = (MSG_TYPE *)malloc(sizeof(MSG_TYPE)*SIZE_MSG_BUFFER);
	int msg_idx = -1;				
	int visible_msg_idx = 0;
	int msg_cnt = -1;
#else
	extern MSG_TYPE *old_msgs;
	extern int msg_idx;			
	extern int visible_msg_idx;
	extern int msg_cnt;
	#define EXTERN extern
#endif

EXTERN	WINDOW *MainWindow;
EXTERN	WINDOW *TitleWindow;
EXTERN	WINDOW *DateTimeWindow;
EXTERN	WINDOW *InterruptWindow;
EXTERN	WINDOW *TimeStepWindow;
EXTERN   WINDOW *CPUWindow;
EXTERN   WINDOW *FileNameWindow;
EXTERN	WINDOW *HeartBeatWindow;
EXTERN	WINDOW *ErrorWindow;
EXTERN	WINDOW *InputWindow;
EXTERN	WINDOW *OutputWindow;
EXTERN	WINDOW *MainStatusWindow;
EXTERN	int maxx,maxy;
EXTERN	char tmpstr[300];

#endif // end of GUI_H 