/***********************************************************************************************/
/************************************** logging.c **********************************************/
/***********************************************************************************************/

#define __LOGGING
#include "logging.h"

/***********************************************************************************************/
/*********************************** put data in a buffer **************************************/
/***********************************************************************************************/
void buffer_data() {

	*(float*)(Data_Cache + Data_Cache_Index_In*RECORD_SIZE + data_cache_sub_index++) = (float)(elapsed);
	*(float*)(Data_Cache + Data_Cache_Index_In*RECORD_SIZE + data_cache_sub_index++) = (float)(sample_time);

   /* your data in addition to the timekeeping data */
	*(float*)(Data_Cache + Data_Cache_Index_In*RECORD_SIZE + data_cache_sub_index++) = (float)(chan_01_c_pos);
	*(float*)(Data_Cache + Data_Cache_Index_In*RECORD_SIZE + data_cache_sub_index++) = (float)(axis_01_c_pos);
	*(float*)(Data_Cache + Data_Cache_Index_In*RECORD_SIZE + data_cache_sub_index++) = (float)(axis_01_cmd_voltage);


}

/***********************************************************************************************/
/*************************** write a buffer if full and start a new one ************************/
/***********************************************************************************************/
void write_buffer() {

		/* when the data goes over a record, switch to a new record and tell the RecordThread it can store the old record.  Hopefully, we have enough records to keep up... */
		if(data_cache_sub_index >= RECORD_SIZE){
			data_cache_sub_index = 0;
			if(++Data_Cache_Index_In == NUMBER_OF_RECORDS) Data_Cache_Index_In = 0;
			if(Wait_for_RecordThread == TRUE){
				/* let the recording thread move this to a file */
				sem_getvalue(&Data_Cache_Sem,&data_semval);
				if(data_semval > NUMBER_OF_RECORDS-1)	PrintErrorMsg("Memory buffer overflow");
				/* wake up the recording thread */
				sem_post(&Data_Cache_Sem);
			}
		} /* filling up the data buffer */

}
/***********************************************************************************************/
/************************* close out an active data thread if still running ********************/
/***********************************************************************************************/
void stop_data_thread(){

   /* check if the data thread is already dead */
   if(Wait_for_RecordThread == TRUE){
		/* send terminate message to the recording thread */
      SendMsg(TO_RECORD_MSG,STOP_RECORDING);
      sem_getvalue(&Data_Cache_Sem,&data_semval);
      if(data_semval == 0) sem_post(&Data_Cache_Sem);  /* need to post this to release the recording thread */
		/* wait for handshake from recording thread that recording thread has ended */
      while(emsg != RELEASE_RECORDING){
			emsg = GetMsg(TO_CONTROL_MSG);
			delay(100);
      }
   }

}
/***********************************************************************************************/
/******************************* determine the size of a file **********************************/
/***********************************************************************************************/
long filesize( FILE *fp)
{
	long int save_pos;
	long size_of_file;

	save_pos = ftell(fp);
	fseek(fp,0L,SEEK_END);
	size_of_file=ftell(fp);
	fseek(fp,save_pos,SEEK_SET);
	return(size_of_file);
}